import { h, Component } from 'preact';
import Section from './section';
import ComponentCode from './component-code';
import { Dialog } from './../dialog';
import { Button } from '../button';

class Container extends Component {
  constructor(props) {
    super(props);
    this.state = {
      open: false
    };
    this.open = () => this.setState({ open: true });
    this.close = () => this.setState({ open: false });
  }

  render(props, { open }) {
    return h(
      Section,
      { title: 'Dialog' },
      h(
        ComponentCode,
        {
          name: 'Dialog',
          code: `<Dialog doClose={this.close} title="A Dialog">
  Hello there
</Dialog>`
        },
        h(
          Button,
          { onClick: this.open },
          'Open'
        ),
        open && h(
          Dialog,
          {
            doClose: this.close,
            title: 'A Dialog with a really, really, ridiculously long title',
            bottom: h(
              'div',
              null,
              h(
                Button,
                { onClick: this.close },
                'Done'
              )
            )
          },
          'Hello there',
          h(
            'p',
            null,
            'long thing'
          ),
          h(
            'p',
            null,
            'long thing'
          ),
          h(
            Button,
            null,
            'Some button'
          )
        )
      )
    );
  }
}

export default Container;