import { h, Component, Fragment } from 'preact';
import { DrugBox, FlipContainer } from '../';
import Section from './section';
import ComponentCode from './component-code';

export class DrugBoxSection extends Component {
  constructor(props) {
    super(props);
    this.state = {
      flipped: false
    };
  }

  render(_, { flipped }) {
    return h(
      Section,
      { title: 'DrugBox' },
      h(
        ComponentCode,
        {
          name: 'DrugBox FlipContainer',
          code: `<FlipContainer
  direction="horizontal"
  perspective="2000px"
  front={
    <DrugBox style={{ width: '200px' }}>
      <div>
        <p>Hi front</p>
        <p>Stuff</p>
        <p>Stuff</p>
        <p>Stuff</p>
        <p>Stuff</p>
        <p>Stuff</p>
        <p>Stuff</p>
        <p>Stuff</p>
      </div>
    </DrugBox>
  }
  back={
    <DrugBox style={{ width: '200px', height: '100%' }}>
      <p>Hi back</p>
      <p>Stuff</p>
      <p>Stuff</p>
      <p>Stuff</p>
    </DrugBox>
  }
  width="200px"
  flipped={flipped}
/>`
        },
        h(
          'button',
          { onClick: () => this.setState({ flipped: !flipped }) },
          'flip'
        ),
        h(
          'div',
          null,
          h(FlipContainer, {
            direction: 'horizontal',
            perspective: '2000px',
            front: h(
              DrugBox,
              { style: { width: '200px' } },
              h(
                'div',
                null,
                h(
                  'p',
                  null,
                  'Hi front'
                ),
                h(
                  'p',
                  null,
                  'Stuff'
                ),
                h(
                  'p',
                  null,
                  'Stuff'
                ),
                h(
                  'p',
                  null,
                  'Stuff'
                ),
                h(
                  'p',
                  null,
                  'Stuff'
                ),
                h(
                  'p',
                  null,
                  'Stuff'
                ),
                h(
                  'p',
                  null,
                  'Stuff'
                ),
                h(
                  'p',
                  null,
                  'Stuff'
                )
              )
            ),
            back: h(
              DrugBox,
              { style: { width: '200px', height: '100%' } },
              h(
                'p',
                null,
                'Hi back'
              ),
              h(
                'p',
                null,
                'Stuff'
              ),
              h(
                'p',
                null,
                'Stuff'
              ),
              h(
                'p',
                null,
                'Stuff'
              )
            ),
            width: '200px',
            flipped: flipped
          })
        )
      )
    );
  }
}